/* Motor de Vida Artificial. Motor 03

Autor: Rafael Alberto Moreno Parra
Pais: Colombia
E-mail: krousky@uniweb.net.co

Investigacin: Vida Artificial
Fecha: 01 de Octubre de 1999

Explicacin:
Genera algoritmos aleatorios que tomando la serie de entrada como valores X
trata de acercarse a la serie de salida (valores Y). Puede usar dos variables mas W y Z.
Muta los mejores algoritmos.
Mas control sobre las probabilidades.

*/

import java.awt.*;
import java.applet.*;
import java.util.*;

public class Motor03 extends Applet implements Runnable
{
    //Trabajar con hilos
	private Thread	 m_thRunner = null;
	
	//Ambiente (series de entrada y salida)
	String m_sEntra = new String();
	String m_sSale = new String();
	
	//Ambiente y ser vivo
	MedioAmbiente objAmbiente = new MedioAmbiente();
	int m_iNumGenes;
	int m_iNumCiclos;
		
	//Contador de Intentos
	int m_iContIntentos;
	
	//Tres primeros puestos
	float m_fPuesto1;
	float m_fPuesto2;
	float m_fPuesto3;
	Organismo OrgPuesto1 = new Organismo();
	Organismo OrgPuesto2 = new Organismo();
	Organismo OrgPuesto3 = new Organismo();
	
	//Probabilidades para construir los genes
    int m_iPosibIf;
    int m_iPosibSet;
    int m_iPosW;
    int m_iPosX;
    int m_iPosY;
    int m_iPosZ;
    int m_iPosIg;
    int m_iPosMay;
    int m_iPosMen;
    int m_iPosDif;
    int m_iLongExpr;
    int m_iPosibX;
    int m_iPosibP;
    int m_iPosibN;
	
    
	public void init()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setSize(735,444);
		lblTitulo.setText("Motor de Vida Artificial. Motor 03.");
		add(lblTitulo);
		lblTitulo.setBackground(java.awt.Color.black);
		lblTitulo.setForeground(java.awt.Color.white);
		lblTitulo.setFont(new Font("Dialog", Font.BOLD, 16));
		lblTitulo.setBounds(12,12,346,26);
		lblEntrada.setText("Valores de Entrada:");
		add(lblEntrada);
		lblEntrada.setBounds(12,48,132,24);
		lblSalida.setText("Valores de Salida esperados:");
		add(lblSalida);
		lblSalida.setBounds(12,72,168,24);
		cmdIniciar.setLabel("Iniciar");
		add(cmdIniciar);
		cmdIniciar.setBounds(12,144,81,23);
		cmdDetener.setLabel("Detener");
		add(cmdDetener);
		cmdDetener.setBounds(108,144,80,22);
		lblGenes.setText("# Maximo de Genes generadas por ser vivo:");
		add(lblGenes);
		lblGenes.setBounds(12,96,288,24);
		cmdSerVivo1.setLabel("Ser Vivo. 1er Puesto");
		add(cmdSerVivo1);
		cmdSerVivo1.setBounds(12,180,176,20);
		cmdSerVivo2.setLabel("Ser Vivo. 2do Puesto");
		add(cmdSerVivo2);
		cmdSerVivo2.setBounds(12,204,176,20);
		cmdSerVivo3.setLabel("Ser Vivo. 3er Puesto");
		add(cmdSerVivo3);
		cmdSerVivo3.setBounds(12,228,176,20);
		txtAprox1.setEditable(false);
		add(txtAprox1);
		txtAprox1.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtAprox1.setBounds(204,180,84,24);
		txtAprox2.setEditable(false);
		add(txtAprox2);
		txtAprox2.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtAprox2.setBounds(204,204,84,24);
		txtAprox3.setEditable(false);
		add(txtAprox3);
		txtAprox3.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtAprox3.setBounds(204,228,84,24);
		txtEntra.setText("1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,");
		add(txtEntra);
		txtEntra.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtEntra.setBounds(180,48,540,24);
		txtSale.setText("2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,");
		add(txtSale);
		txtSale.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtSale.setBounds(180,72,540,24);
		txtGenes.setText("10");
		add(txtGenes);
		txtGenes.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtGenes.setBounds(300,96,36,19);
		add(txtCodFuente);
		txtCodFuente.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtCodFuente.setBounds(348,120,372,288);
		lblSerVivoCodFu.setText("Ser Vivo");
		add(lblSerVivoCodFu);
		lblSerVivoCodFu.setBounds(348,96,48,24);
		lblIntento.setText("Intento #:");
		add(lblIntento);
		lblIntento.setBounds(12,252,95,20);
		txtIntento.setEditable(false);
		add(txtIntento);
		txtIntento.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtIntento.setBounds(108,252,82,23);
		lblCiclosSerVivo.setText("# Mximo de Ciclos CPU para el Ser Vivo:");
		add(lblCiclosSerVivo);
		lblCiclosSerVivo.setBounds(12,120,274,21);
		txtCiclos.setText("30");
		add(txtCiclos);
		txtCiclos.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtCiclos.setBounds(300,120,36,19);
		txtPuesto.setEditable(false);
		add(txtPuesto);
		txtPuesto.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtPuesto.setBounds(408,96,312,24);
		cmdContinuar.setLabel("Continuar");
		add(cmdContinuar);
		cmdContinuar.setBounds(204,144,83,21);
		lblAvanzado.setText("Propiedades Avanzadas");
		add(lblAvanzado);
		lblAvanzado.setBackground(java.awt.Color.black);
		lblAvanzado.setForeground(java.awt.Color.white);
		lblAvanzado.setFont(new Font("Dialog", Font.BOLD, 12));
		lblAvanzado.setBounds(12,288,144,24);
		label1.setText("Probabilidad de IF:");
		add(label1);
		label1.setBounds(12,312,108,24);
		lblProbAsig.setText("Asignacin:");
		add(lblProbAsig);
		lblProbAsig.setBounds(180,312,72,24);
		lblVarActivaW.setText("Variable Activa. W=");
		add(lblVarActivaW);
		lblVarActivaW.setBounds(12,336,108,24);
		lblVarActivaX.setText("X=");
		add(lblVarActivaX);
		lblVarActivaX.setBounds(156,336,24,24);
		lblVarActivaY.setText("Y=");
		add(lblVarActivaY);
		lblVarActivaY.setBounds(228,336,24,24);
		lblVarActivaZ.setText("Z=");
		add(lblVarActivaZ);
		lblVarActivaZ.setBounds(288,336,24,24);
		lblOperacion1.setText("Oper = Igual");
		add(lblOperacion1);
		lblOperacion1.setBounds(12,360,72,24);
		lblOperac2.setText("> Mayor");
		add(lblOperac2);
		lblOperac2.setBounds(120,360,48,24);
		lblPosMenor.setText("< Menor");
		add(lblPosMenor);
		lblPosMenor.setBounds(192,360,48,24);
		lblPosDif.setText("! Difer.");
		add(lblPosDif);
		lblPosDif.setBounds(276,360,36,24);
		lblPosX.setText("X=");
		add(lblPosX);
		lblPosX.setBounds(108,384,17,24);
		lblPosParent.setText("Parntesis =");
		add(lblPosParent);
		lblPosParent.setBounds(156,384,72,24);
		lblPosNumer.setText("Numero=");
		add(lblPosNumer);
		lblPosNumer.setBounds(264,384,48,24);
		txtProbIF.setText("50");
		add(txtProbIF);
		txtProbIF.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtProbIF.setBounds(120,312,36,24);
		lblLongExpr.setText("Longitud");
		add(lblLongExpr);
		lblLongExpr.setBounds(12,384,60,24);
		txtLongExpr.setText("10");
		add(txtLongExpr);
		txtLongExpr.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtLongExpr.setBounds(72,384,36,24);
		txtProbSET.setText("50");
		add(txtProbSET);
		txtProbSET.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtProbSET.setBounds(252,312,36,24);
		txtProbW.setText("25");
		add(txtProbW);
		txtProbW.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtProbW.setBounds(120,336,27,24);
		txtProbX.setText("25");
		add(txtProbX);
		txtProbX.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtProbX.setBounds(180,336,39,24);
		add(txtProbExpX);
		txtProbExpX.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtProbExpX.setBounds(132,384,24,24);
		txtProbParen.setText("10");
		txtProbY.setText("25");
		add(txtProbY);
		txtProbY.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtProbY.setBounds(252,336,34,24);
		txtProbZ.setText("25");
		add(txtProbZ);
		txtProbZ.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtProbZ.setBounds(312,336,30,24);
		txtProbIgual.setText("25");
		add(txtProbIgual);
		txtProbIgual.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtProbIgual.setBounds(84,360,24,24);
		txtProbMay.setText("25");
		add(txtProbMay);
		txtProbMay.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtProbMay.setBounds(168,360,28,24);
		txtProbMen.setText("25");
		add(txtProbMen);
		txtProbMen.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtProbMen.setBounds(240,360,25,24);
		txtProbDif.setText("25");
		add(txtProbDif);
		txtProbDif.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtProbDif.setBounds(312,360,29,24);
		txtProbExpX.setText("40");
		add(txtProbExpX);
		add(txtProbParen);
		txtProbParen.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtProbParen.setBounds(228,384,36,24);
		txtProbNum.setText("50");
		add(txtProbNum);
		txtProbNum.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtProbNum.setBounds(312,384,37,24);
		add(lblLongExpr);
		add(lblLongExpr);
		//}}
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		cmdIniciar.addActionListener(lSymAction);
		cmdDetener.addActionListener(lSymAction);
		cmdSerVivo1.addActionListener(lSymAction);
		cmdSerVivo2.addActionListener(lSymAction);
		cmdSerVivo3.addActionListener(lSymAction);
		cmdContinuar.addActionListener(lSymAction);
		txtGenes.addActionListener(lSymAction);
		//}}

    	IniciarValores();
	
	}
	
	//{{DECLARE_CONTROLS
	java.awt.Label lblTitulo = new java.awt.Label();
	java.awt.Label lblEntrada = new java.awt.Label();
	java.awt.Label lblSalida = new java.awt.Label();
	java.awt.Button cmdIniciar = new java.awt.Button();
	java.awt.Button cmdDetener = new java.awt.Button();
	java.awt.Label lblGenes = new java.awt.Label();
	java.awt.Button cmdSerVivo1 = new java.awt.Button();
	java.awt.Button cmdSerVivo2 = new java.awt.Button();
	java.awt.Button cmdSerVivo3 = new java.awt.Button();
	java.awt.TextField txtAprox1 = new java.awt.TextField();
	java.awt.TextField txtAprox2 = new java.awt.TextField();
	java.awt.TextField txtAprox3 = new java.awt.TextField();
	java.awt.TextField txtEntra = new java.awt.TextField();
	java.awt.TextField txtSale = new java.awt.TextField();
	java.awt.TextField txtGenes = new java.awt.TextField();
	java.awt.TextArea txtCodFuente = new java.awt.TextArea();
	java.awt.Label lblSerVivoCodFu = new java.awt.Label();
	java.awt.Label lblIntento = new java.awt.Label();
	java.awt.TextField txtIntento = new java.awt.TextField();
	java.awt.Label lblCiclosSerVivo = new java.awt.Label();
	java.awt.TextField txtCiclos = new java.awt.TextField();
	java.awt.TextField txtPuesto = new java.awt.TextField();
	java.awt.Button cmdContinuar = new java.awt.Button();
	java.awt.Label lblAvanzado = new java.awt.Label();
	java.awt.Label label1 = new java.awt.Label();
	java.awt.Label lblProbAsig = new java.awt.Label();
	java.awt.Label lblVarActivaW = new java.awt.Label();
	java.awt.Label lblVarActivaX = new java.awt.Label();
	java.awt.Label lblVarActivaY = new java.awt.Label();
	java.awt.Label lblVarActivaZ = new java.awt.Label();
	java.awt.Label lblOperacion1 = new java.awt.Label();
	java.awt.Label lblOperac2 = new java.awt.Label();
	java.awt.Label lblPosMenor = new java.awt.Label();
	java.awt.Label lblPosDif = new java.awt.Label();
	java.awt.Label lblPosX = new java.awt.Label();
	java.awt.Label lblPosParent = new java.awt.Label();
	java.awt.Label lblPosNumer = new java.awt.Label();
	java.awt.TextField txtProbIF = new java.awt.TextField();
	java.awt.TextField txtLongExpr = new java.awt.TextField();
	java.awt.TextField txtProbSET = new java.awt.TextField();
	java.awt.TextField txtProbW = new java.awt.TextField();
	java.awt.TextField txtProbX = new java.awt.TextField();
	java.awt.TextField txtProbY = new java.awt.TextField();
	java.awt.TextField txtProbZ = new java.awt.TextField();
	java.awt.TextField txtProbIgual = new java.awt.TextField();
	java.awt.TextField txtProbMay = new java.awt.TextField();
	java.awt.TextField txtProbMen = new java.awt.TextField();
	java.awt.TextField txtProbDif = new java.awt.TextField();
	java.awt.TextField txtProbExpX = new java.awt.TextField();
	java.awt.TextField txtProbParen = new java.awt.TextField();
	java.awt.TextField txtProbNum = new java.awt.TextField();
	java.awt.Label lblLongExpr = new java.awt.Label();
	//}}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == cmdIniciar)
				cmdIniciar_ActionPerformed(event);
			else if (object == cmdDetener)
				cmdDetener_ActionPerformed(event);
			else if (object == cmdSerVivo1)
				cmdSerVivo1_ActionPerformed(event);
			else if (object == cmdSerVivo2)
				cmdSerVivo2_ActionPerformed(event);
			else if (object == cmdSerVivo3)
				cmdSerVivo3_ActionPerformed(event);
			else if (object == cmdContinuar)
				cmdContinuar_ActionPerformed(event);
			else if (object == txtGenes)
				txtGenes_ActionPerformed(event);
		}
	}

	void cmdIniciar_ActionPerformed(java.awt.event.ActionEvent event)
	{
	    IniciarValores();
		start();
	}

	void cmdDetener_ActionPerformed(java.awt.event.ActionEvent event)
	{
        stop();			 
	}
	
	void cmdContinuar_ActionPerformed(java.awt.event.ActionEvent event)
	{
	    start();
	}

	void cmdSerVivo1_ActionPerformed(java.awt.event.ActionEvent event)
	{
         txtCodFuente.setText(OrgPuesto1.sDisplayADN());
         txtPuesto.setText("1er Puesto. Aprox:" + txtAprox1.getText());
	}

	void cmdSerVivo2_ActionPerformed(java.awt.event.ActionEvent event)
	{
         txtCodFuente.setText(OrgPuesto2.sDisplayADN());
         txtPuesto.setText("2do Puesto. Aprox:" + txtAprox2.getText());
	}

	void cmdSerVivo3_ActionPerformed(java.awt.event.ActionEvent event)
	{
         txtCodFuente.setText(OrgPuesto3.sDisplayADN());
         txtPuesto.setText("3er Puesto. Aprox:" + txtAprox3.getText());
	}
	
	public void start()
	{
		if (m_thRunner == null)
		{
			m_thRunner = new Thread(this);
			m_thRunner.start();
		}
	}
	
	public void stop()
	{
		if (m_thRunner != null)
		{
			m_thRunner.stop();
			m_thRunner=null;
		}	

	}

	public void run()
	{
		float fResult, fErrOrg;
		int iCont, iCopia;
		int iNumCiclo;
		
		//Genera seres vivos aleatoriamente, luego comienza a mutarlos.
		OrgPuesto1.vCreaADN(m_iNumGenes, m_iNumCiclos,
                    m_iPosibIf, m_iPosibSet,
                    m_iPosW, m_iPosX, m_iPosY, m_iPosZ, 
                    m_iPosIg, m_iPosMay, m_iPosMen, m_iPosDif,
                    m_iLongExpr, m_iPosibX, m_iPosibP, m_iPosibN);
        
		OrgPuesto2.vCreaADN(m_iNumGenes, m_iNumCiclos,
                    m_iPosibIf, m_iPosibSet,
                    m_iPosW, m_iPosX, m_iPosY, m_iPosZ, 
                    m_iPosIg, m_iPosMay, m_iPosMen, m_iPosDif,
                    m_iLongExpr, m_iPosibX, m_iPosibP, m_iPosibN);
        
		OrgPuesto3.vCreaADN(m_iNumGenes, m_iNumCiclos,
                    m_iPosibIf, m_iPosibSet,
                    m_iPosW, m_iPosX, m_iPosY, m_iPosZ, 
                    m_iPosIg, m_iPosMay, m_iPosMen, m_iPosDif,
                    m_iLongExpr, m_iPosibX, m_iPosibP, m_iPosibN);
                    
        int iMutar=1;
		Random mAleat = new Random();
        Organismo oSerVivo = new Organismo();
		oSerVivo.vCreaADN(m_iNumGenes, m_iNumCiclos,
                    m_iPosibIf, m_iPosibSet,
                    m_iPosW, m_iPosX, m_iPosY, m_iPosZ, 
                    m_iPosIg, m_iPosMay, m_iPosMen, m_iPosDif,
                    m_iLongExpr, m_iPosibX, m_iPosibP, m_iPosibN);
        
		while(true)
		{
            m_iContIntentos++;
            
            
            //Distribuye las mutaciones
            switch(iMutar)
            {
                case 1:
                    for (iCopia=1; iCopia <= OrgPuesto1.iMaxGenOrg; iCopia++)
                    {
                        oSerVivo.oGen[iCopia].cOperacion = OrgPuesto1.oGen[iCopia].cOperacion;
                        oSerVivo.oGen[iCopia].cTipInst = OrgPuesto1.oGen[iCopia].cTipInst;
                        oSerVivo.oGen[iCopia].cVarActiva = OrgPuesto1.oGen[iCopia].cVarActiva;
                        oSerVivo.oGen[iCopia].cVariable = OrgPuesto1.oGen[iCopia].cVariable;
                        oSerVivo.oGen[iCopia].iGotoLabel = OrgPuesto1.oGen[iCopia].iGotoLabel;
                        oSerVivo.oGen[iCopia].sbExpresion = OrgPuesto1.oGen[iCopia].sbExpresion;
                        //System.out.println("1.Copiando=" + OrgPuesto1.oGen[iCopia].sbExpresion);
                    }
                    oSerVivo.iMaxGenOrg = OrgPuesto1.iMaxGenOrg;
                    oSerVivo.iMaxiCiclos = OrgPuesto1.iMaxiCiclos;
                    oSerVivo.vEvaluaPrevio();
                    iMutar=2;
                    break;
                case 2:
                    for (iCopia=1; iCopia <= OrgPuesto2.iMaxGenOrg; iCopia++)
                    {
                        oSerVivo.oGen[iCopia].cOperacion = OrgPuesto2.oGen[iCopia].cOperacion;
                        oSerVivo.oGen[iCopia].cTipInst = OrgPuesto2.oGen[iCopia].cTipInst;
                        oSerVivo.oGen[iCopia].cVarActiva = OrgPuesto2.oGen[iCopia].cVarActiva;
                        oSerVivo.oGen[iCopia].cVariable = OrgPuesto2.oGen[iCopia].cVariable;
                        oSerVivo.oGen[iCopia].iGotoLabel = OrgPuesto2.oGen[iCopia].iGotoLabel;
                        oSerVivo.oGen[iCopia].sbExpresion = OrgPuesto2.oGen[iCopia].sbExpresion;
                        //System.out.println("2.Copiando=" + OrgPuesto2.oGen[iCopia].sbExpresion);
                    }
                    oSerVivo.iMaxGenOrg = OrgPuesto2.iMaxGenOrg;
                    oSerVivo.iMaxiCiclos = OrgPuesto2.iMaxiCiclos;
                    oSerVivo.vEvaluaPrevio();
                    iMutar=3;
                    break;
                case 3:
                    for (iCopia=1; iCopia <= OrgPuesto3.iMaxGenOrg; iCopia++)
                    {
                        oSerVivo.oGen[iCopia].cOperacion = OrgPuesto3.oGen[iCopia].cOperacion;
                        oSerVivo.oGen[iCopia].cTipInst = OrgPuesto3.oGen[iCopia].cTipInst;
                        oSerVivo.oGen[iCopia].cVarActiva = OrgPuesto3.oGen[iCopia].cVarActiva;
                        oSerVivo.oGen[iCopia].cVariable = OrgPuesto3.oGen[iCopia].cVariable;
                        oSerVivo.oGen[iCopia].iGotoLabel = OrgPuesto3.oGen[iCopia].iGotoLabel;
                        oSerVivo.oGen[iCopia].sbExpresion = OrgPuesto3.oGen[iCopia].sbExpresion;
                        //System.out.println("3.Copiando=" + OrgPuesto3.oGen[iCopia].sbExpresion);
                    }
                    oSerVivo.iMaxGenOrg = OrgPuesto3.iMaxGenOrg;
                    oSerVivo.iMaxiCiclos = OrgPuesto3.iMaxiCiclos;
                    oSerVivo.vEvaluaPrevio();
                    iMutar=4;
                    break;
               case 4:
		            oSerVivo.vCreaADN(m_iNumGenes, m_iNumCiclos,
                                        m_iPosibIf, m_iPosibSet,
                                        m_iPosW, m_iPosX, m_iPosY, m_iPosZ, 
                                        m_iPosIg, m_iPosMay, m_iPosMen, m_iPosDif,
                                        m_iLongExpr, m_iPosibX, m_iPosibP, m_iPosibN);
                    oSerVivo.vEvaluaPrevio();                                        
                    iMutar=1;
                    break;
            }
//            System.out.println("A mutar");

            //Muta el ser vivo, decide en que Gen
            iNumCiclo = Math.abs(mAleat.nextInt() % oSerVivo.iMaxGenOrg ) + 1;
            
  //          System.out.println("Gen Muta:" + iNumCiclo + " de:" + oSerVivo.iMaxGenOrg);

            oSerVivo.Muta(iNumCiclo, oSerVivo.iMaxGenOrg,
                    m_iPosibIf, m_iPosibSet,
                    m_iPosW, m_iPosX, m_iPosY, m_iPosZ, 
                    m_iPosIg, m_iPosMay, m_iPosMen, m_iPosDif,
                    m_iLongExpr, m_iPosibX, m_iPosibP, m_iPosibN);
            
           txtIntento.setText(String.valueOf(m_iContIntentos));

	        /* Compara la cadena de salida del organismo con la requerida */
            fErrOrg=0;
	        for (iCont=0; iCont<objAmbiente.m_iContEntra; iCont++)
	        {
	            fResult = oSerVivo.fEvalOrganismo((float)objAmbiente.m_iEntradas[iCont]);
	            fErrOrg += Math.abs(fResult-(float)objAmbiente.m_iSalidas[iCont]);
	        }
	        
	        /* Compara con los tres puestos */
	        if (fErrOrg < m_fPuesto1)
	        {
	            //OrgPuesto3 = OrgPuesto2;
                for (iCopia=1; iCopia <= OrgPuesto2.iMaxGenOrg; iCopia++)
                {
                    OrgPuesto3.oGen[iCopia].cOperacion = OrgPuesto2.oGen[iCopia].cOperacion;
                    OrgPuesto3.oGen[iCopia].cTipInst = OrgPuesto2.oGen[iCopia].cTipInst;
                    OrgPuesto3.oGen[iCopia].cVarActiva = OrgPuesto2.oGen[iCopia].cVarActiva;
                    OrgPuesto3.oGen[iCopia].cVariable = OrgPuesto2.oGen[iCopia].cVariable;
                    OrgPuesto3.oGen[iCopia].iGotoLabel = OrgPuesto2.oGen[iCopia].iGotoLabel;
                    OrgPuesto3.oGen[iCopia].sbExpresion = OrgPuesto2.oGen[iCopia].sbExpresion;
                }
                OrgPuesto3.iMaxGenOrg = OrgPuesto2.iMaxGenOrg;
                OrgPuesto3.iMaxiCiclos = OrgPuesto2.iMaxiCiclos;
	            
	            //OrgPuesto2 = OrgPuesto1;
                for (iCopia=1; iCopia <= OrgPuesto1.iMaxGenOrg; iCopia++)
                {
                    OrgPuesto2.oGen[iCopia].cOperacion = OrgPuesto1.oGen[iCopia].cOperacion;
                    OrgPuesto2.oGen[iCopia].cTipInst = OrgPuesto1.oGen[iCopia].cTipInst;
                    OrgPuesto2.oGen[iCopia].cVarActiva = OrgPuesto1.oGen[iCopia].cVarActiva;
                    OrgPuesto2.oGen[iCopia].cVariable = OrgPuesto1.oGen[iCopia].cVariable;
                    OrgPuesto2.oGen[iCopia].iGotoLabel = OrgPuesto1.oGen[iCopia].iGotoLabel;
                    OrgPuesto2.oGen[iCopia].sbExpresion = OrgPuesto1.oGen[iCopia].sbExpresion;
                }
                OrgPuesto2.iMaxGenOrg = OrgPuesto1.iMaxGenOrg;
                OrgPuesto2.iMaxiCiclos = OrgPuesto1.iMaxiCiclos;

	            //OrgPuesto1 = oSerVivo;
                for (iCopia=1; iCopia <= oSerVivo.iMaxGenOrg; iCopia++)
                {
                    OrgPuesto1.oGen[iCopia].cOperacion = oSerVivo.oGen[iCopia].cOperacion;
                    OrgPuesto1.oGen[iCopia].cTipInst = oSerVivo.oGen[iCopia].cTipInst;
                    OrgPuesto1.oGen[iCopia].cVarActiva = oSerVivo.oGen[iCopia].cVarActiva;
                    OrgPuesto1.oGen[iCopia].cVariable = oSerVivo.oGen[iCopia].cVariable;
                    OrgPuesto1.oGen[iCopia].iGotoLabel = oSerVivo.oGen[iCopia].iGotoLabel;
                    OrgPuesto1.oGen[iCopia].sbExpresion = oSerVivo.oGen[iCopia].sbExpresion;
                }
                OrgPuesto1.iMaxGenOrg = oSerVivo.iMaxGenOrg;
                OrgPuesto1.iMaxiCiclos = oSerVivo.iMaxiCiclos;
	            
	            
	            m_fPuesto3 = m_fPuesto2;
	            m_fPuesto2 = m_fPuesto1;
	            m_fPuesto1 = fErrOrg;
	            
	            txtAprox1.setText(String.valueOf(m_fPuesto1));
	            txtAprox2.setText(String.valueOf(m_fPuesto2));
	            txtAprox3.setText(String.valueOf(m_fPuesto3));
	        }
	        else
	        if (fErrOrg < m_fPuesto2)
	        {
  	            //OrgPuesto3 = OrgPuesto2;
                for (iCopia=1; iCopia <= OrgPuesto2.iMaxGenOrg; iCopia++)
                {
                    OrgPuesto3.oGen[iCopia].cOperacion = OrgPuesto2.oGen[iCopia].cOperacion;
                    OrgPuesto3.oGen[iCopia].cTipInst = OrgPuesto2.oGen[iCopia].cTipInst;
                    OrgPuesto3.oGen[iCopia].cVarActiva = OrgPuesto2.oGen[iCopia].cVarActiva;
                    OrgPuesto3.oGen[iCopia].cVariable = OrgPuesto2.oGen[iCopia].cVariable;
                    OrgPuesto3.oGen[iCopia].iGotoLabel = OrgPuesto2.oGen[iCopia].iGotoLabel;
                    OrgPuesto3.oGen[iCopia].sbExpresion = OrgPuesto2.oGen[iCopia].sbExpresion;
                }
                OrgPuesto3.iMaxGenOrg = OrgPuesto2.iMaxGenOrg;
                OrgPuesto3.iMaxiCiclos = OrgPuesto2.iMaxiCiclos;

	            //OrgPuesto2 = oSerVivo;
                for (iCopia=1; iCopia <= oSerVivo.iMaxGenOrg; iCopia++)
                {
                    OrgPuesto2.oGen[iCopia].cOperacion = oSerVivo.oGen[iCopia].cOperacion;
                    OrgPuesto2.oGen[iCopia].cTipInst = oSerVivo.oGen[iCopia].cTipInst;
                    OrgPuesto2.oGen[iCopia].cVarActiva = oSerVivo.oGen[iCopia].cVarActiva;
                    OrgPuesto2.oGen[iCopia].cVariable = oSerVivo.oGen[iCopia].cVariable;
                    OrgPuesto2.oGen[iCopia].iGotoLabel = oSerVivo.oGen[iCopia].iGotoLabel;
                    OrgPuesto2.oGen[iCopia].sbExpresion = oSerVivo.oGen[iCopia].sbExpresion;
                }
                OrgPuesto2.iMaxGenOrg = oSerVivo.iMaxGenOrg;
                OrgPuesto2.iMaxiCiclos = oSerVivo.iMaxiCiclos;

	            m_fPuesto3 = m_fPuesto2;
	            m_fPuesto2 = fErrOrg;
	            
	            txtAprox2.setText(String.valueOf(m_fPuesto2));
	            txtAprox3.setText(String.valueOf(m_fPuesto3));
	        }
	        else
	        if (fErrOrg < m_fPuesto3)
	        {
	            // OrgPuesto3 = oSerVivo
                for (iCopia=1; iCopia <= oSerVivo.iMaxGenOrg; iCopia++)
                {
                    OrgPuesto3.oGen[iCopia].cOperacion = oSerVivo.oGen[iCopia].cOperacion;
                    OrgPuesto3.oGen[iCopia].cTipInst = oSerVivo.oGen[iCopia].cTipInst;
                    OrgPuesto3.oGen[iCopia].cVarActiva = oSerVivo.oGen[iCopia].cVarActiva;
                    OrgPuesto3.oGen[iCopia].cVariable = oSerVivo.oGen[iCopia].cVariable;
                    OrgPuesto3.oGen[iCopia].iGotoLabel = oSerVivo.oGen[iCopia].iGotoLabel;
                    OrgPuesto3.oGen[iCopia].sbExpresion = oSerVivo.oGen[iCopia].sbExpresion;
                }
                OrgPuesto3.iMaxGenOrg = oSerVivo.iMaxGenOrg;
                OrgPuesto3.iMaxiCiclos = oSerVivo.iMaxiCiclos;

	            m_fPuesto3 = fErrOrg;

	            txtAprox3.setText(String.valueOf(m_fPuesto3));
	        }
	    }
	}
	
    void IniciarValores()
	{
        //Posibilidades para creacin de genes:
        m_iPosibIf= Integer.parseInt(txtProbIF.getText());
        m_iPosibSet= Integer.parseInt(txtProbSET.getText());
        m_iPosW= Integer.parseInt(txtProbW.getText());
        m_iPosX= Integer.parseInt(txtProbX.getText());
        m_iPosY= Integer.parseInt(txtProbY.getText());
        m_iPosZ= Integer.parseInt(txtProbZ.getText());
        m_iPosIg= Integer.parseInt(txtProbIgual.getText());
        m_iPosMay= Integer.parseInt(txtProbMay.getText());
        m_iPosMen= Integer.parseInt(txtProbMen.getText());
        m_iPosDif= Integer.parseInt(txtProbDif.getText());
        m_iLongExpr= Integer.parseInt(txtLongExpr.getText());
        m_iPosibX= Integer.parseInt(txtProbExpX.getText());
        m_iPosibP= Integer.parseInt(txtProbParen.getText());
        m_iPosibN= Integer.parseInt(txtProbNum.getText());
		
	    //El ambiente
		m_sEntra = txtEntra.getText();
		m_sSale = txtSale.getText();
	    objAmbiente.vDeshaceIO(m_sEntra, 1);
	    objAmbiente.vDeshaceIO(m_sSale, 2);
		
    	//Valores iniciales de los puestos
		txtAprox1.setText("9999999");
		txtAprox2.setText("9999999");
		txtAprox3.setText("9999999");
        
		//Contador de Intentos
		m_iContIntentos = 0;
		
		//Inicializa los puestos
		m_fPuesto1 = (float) 9999999;
		m_fPuesto2 = (float) 9999999;
		m_fPuesto3 = (float) 9999999;
		
		//Inicializa los genes y el numero de ciclos CPU requeridos para evaluar ser vivo
		m_iNumGenes = Integer.parseInt(txtGenes.getText());
		if (m_iNumGenes > 70)
		{
		    m_iNumGenes = 70;
		    txtGenes.setText("70");
		}
		m_iNumCiclos = Integer.parseInt(txtCiclos.getText());
	}	

	void txtGenes_ActionPerformed(java.awt.event.ActionEvent event)
	{
		if (Integer.parseInt(txtGenes.getText()) > 70)
		    txtGenes.setText("70");
	}
}
